name = "Network"
desc = "Basic Networking"
 
from gtk import *
from GTK import *
 
import re 

from utils import *
 
class applet(Applet): 
 
    def __init__(self): 
 
        Applet.__init__(self) 


        fin = open('/etc/pcmcia/network.opts','r')  
	data = fin.read();
        fin.close()

	data = re.sub('\n', ' ', data)
        bootpfind = re.compile('bootp=\\"([ny])\\"', re.IGNORECASE)
        dhcpfind = re.compile('dhcp=\\"([ny])\\"', re.IGNORECASE)
        pumpfind = re.compile('pump=\\"([ny])\\"', re.IGNORECASE)
        ipaddrfind = re.compile('ipaddr=\\"([0-9.:a-f])\\"', re.IGNORECASE)
        broadcastfind = re.compile('broadcast=\\"([0-9.:a-f])\\"', re.IGNORECASE)
        gatewayfind = re.compile('gateway=\\"([0-9.:a-f])\\"', re.IGNORECASE)
        netmaskfind = re.compile('netmask=\\"([0-9.:a-f])\\"', re.IGNORECASE)
        domainfind = re.compile('domain=\\"([^"])\\"', re.IGNORECASE)

        self.box = GtkVBox() 
        self.add(self.box) 
        self.box.show() 
 
        lbl = GtkLabel('Basic Networking') 
        self.box.pack_start(lbl,expand=FALSE) 
        lbl.show() 
 
        hb = GtkHBox() 
        lbl=GtkLabel('Domain:') 
        hb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.domain = GtkEntry()
	founddomain = domainfind.search(data)
	if founddomain:
            self.domain.set_text(founddomain.group(1))
	else:
            self.domain.set_text('')
        hb.pack_end(self.domain)
	self.domain.show()
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 

        hb = GtkHBox() 
        button1=GtkRadioButton(label='BOOTP')
        hb.pack_start(button1 ,expand=FALSE) 
        button2=GtkRadioButton(button1, label='DHCP')
        hb.pack_start(button2 ,expand=FALSE) 
        button3=GtkRadioButton(button1, label='PUMP')
        hb.pack_start(button3 ,expand=FALSE) 
        button4=GtkRadioButton(button1, label='Manual')
        hb.pack_start(button4 ,expand=FALSE) 
        lbl.show() 
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 

        button4.clicked()
	foundbootp = bootpfind.search(data)
	if foundbootp:
	    if 'y' == foundbootp.group(1):
		button1.clicked();
	    if 'Y' == foundbootp.group(1):
		button1.clicked();
	founddhcp = dhcpfind.search(data)
	if founddhcp:
	    if 'y' == founddhcp.group(1):
		button2.clicked();
	    if 'Y' == founddhcp.group(1):
		button2.clicked();
	foundpump = pumpfind.search(data)
	if foundpump:
	    if 'y' == foundpump.group(1):
		button3.clicked();
	    if 'Y' == foundpump.group(1):
		button3.clicked();
        button1.show()
        button2.show()
        button3.show()
        button4.show()


 
        hb = GtkHBox() 
        lbl=GtkLabel('IP Addr:') 
        hb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.ipaddr = GtkEntry()
	foundipaddr = ipaddrfind.search(data)
	if foundipaddr:
            self.ipaddr.set_text(foundipaddr.group(1))
	else:
            self.ipaddr.set_text('')
        hb.pack_start(self.ipaddr)
	self.ipaddr.show()
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 

        hb = GtkHBox() 
        lbl=GtkLabel('Netmask:') 
        hb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.netmask = GtkEntry()
	foundnetmask = netmaskfind.search(data)
	if foundnetmask:
            self.netmask.set_text(foundnetmask.group(1))
	else:
            self.netmask.set_text('')
        hb.pack_start(self.netmask)
	self.netmask.show()
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 

        hb = GtkHBox() 
        lbl=GtkLabel('Gateway:') 
        hb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.gateway = GtkEntry()
	foundgateway = gatewayfind.search(data)
	if foundgateway:
            self.gateway.set_text(foundgateway.group(1))
	else:
            self.gateway.set_text('')
        hb.pack_start(self.gateway)
	self.gateway.show()
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 

        hb = GtkHBox() 
        lbl=GtkLabel('Broadcast:') 
        hb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.broadcast = GtkEntry()
	foundbroadcast = broadcastfind.search(data)
	if foundbroadcast:
            self.broadcast.set_text(foundbroadcast.group(1))
	else:
            self.broadcast.set_text('')
        hb.pack_start(self.broadcast)
	self.broadcast.show()
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 


	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 

    def save(self,msgbox=FALSE): 
        import os 


        fin = open('/etc/pcmcia/network.opts','r')  
	data = fin.read();
        fin.close()

        bootpfind = re.compile('bootp=\\"([np])\\"', re.IGNORECASE)
        dhcpfind = re.compile('dhcp=\\"([np])\\"', re.IGNORECASE)
        pumpfind = re.compile('pump=\\"([np])\\"', re.IGNORECASE)
        ipaddrfind = re.compile('ipaddr=\\"([0-9.:a-f])\\"', re.IGNORECASE)
        broadcastfind = re.compile('broadcast=\\"([0-9.:a-f])\\"', re.IGNORECASE)
        gatewayfind = re.compile('gateway=\\"([0-9.:a-f])\\"', re.IGNORECASE)
        netmaskfind = re.compile('netmask=\\"([0-9.:a-f])\\"', re.IGNORECASE)
        domainfind = re.compile('domain=\\"([^"])\\"', re.IGNORECASE)


	if button1.get_active():
	    data = bootpfind.sub('BOOTP="Y"\n', data)
	else:
	    data = bootpfind.sub('BOOTP="N"\n', data)
	if button2.get_active():
	    data = dhcpfind.sub('DHCP="Y"\n', data)
	else:
	    data = dhcpfind.sub('DHCP="N"\n', data)
	if button3.get_active():
	    data = pumpfind.sub('PUMP="Y"\n', data)
	else:
	    data = pumpfind.sub('PUMP="N"\n', data)

	data = ipaddrfind.sub('IPADDR="%s"\n' % self.ipaddr.get_text(), data)
	data = broadcastfind.sub('BROADCAST="%s"\n' % self.broadcast.get_text(), data)
	data = gatewayfind.sub('GATEWAY="%s"\n' % self.gateway.get_text(), data)
	data = netmaskfind.sub('NETMASK="%s"\n' % self.netmask.get_text(), data)
	data = domainfind.sub('DOMAIN="%s"\n' % self.domain.get_text(), data)

        fout = open('/etc/pcmcia/network.opts','w')  
        fout.write(data)
        fout.close() 

        os.system('chmod 555 /etc/pcmcia/network.opts')

        os.system('/etc/pcmcia/network stop eth0')
        os.system('/etc/pcmcia/network start eth0')


        ret = Applet.save(self,msgbox) 
 
applet_instance = applet() 
