name = "Wlan"
desc = "Set encription strings"
 
from gtk import *
from GTK import *
 
import re 

from utils import *
 
class applet(Applet): 
 
    def __init__(self): 
 
        Applet.__init__(self) 


        fin = open('/etc/pcmcia/wireless.opts','r')  
	data = fin.read();
        fin.close()

	data = re.sub('\n', ' ', data)
        essidfind = re.compile('essid=\\"([^"]*)\\"', re.IGNORECASE)
        keyfind = re.compile('KEY=\\"([^"]*)\\"')
        keyfindthree = re.compile('^(.*) enc \\[3\\] ?([^ ]+)$')
        keyfindtwo   = re.compile('^(.*) enc \\[2\\] ?([^ ]+)$')
        keyfindone   = re.compile('^(.*) enc \\[1\\] ?([^ ]+)$')

	foundessid = essidfind.search(data)
	foundkey = keyfind.search(data)

        self.box = GtkVBox() 
        self.add(self.box) 
        self.box.show() 
 
        lbl = GtkLabel('Wireless Encryption') 
        self.box.pack_start(lbl,expand=FALSE) 
        lbl.show() 
 
        hb = GtkHBox() 
        lbl=GtkLabel('Interface:') 
        hb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.interface = GtkEntry()
        self.interface.set_text('eth0')
        hb.pack_end(self.interface)
	self.interface.show()
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 

        hb = GtkHBox() 
        lbl=GtkLabel('ESSID:') 
        hb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.essid = GtkEntry()
	if foundessid:
	   self.essid.set_text(foundessid.group(1))
	else:
	   self.essid.set_text('ANY')
        hb.pack_end(self.essid)
	self.essid.show()
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 

        hb = GtkHBox() 
        lbl=GtkLabel('an encription string is either hexadecimal,\nlike AB-CD-EF-01-23\nor a word preceeded by s: \nlike s:password') 
        hb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 

 
        hb = GtkHBox() 
	vb = GtkVBox()
        lbl=GtkLabel('ENC:') 
        vb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        lbl=GtkLabel('') 
        vb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        lbl=GtkLabel('') 
        vb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        lbl=GtkLabel('') 
        vb.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        hb.pack_start(vb,expand=FALSE) 
        vb.show()
	vb = GtkVBox()
        self.enca = GtkEntry()
        self.encb = GtkEntry()
        self.encc = GtkEntry()
        self.encd = GtkEntry()
        self.encd.set_text('')
        self.encc.set_text('')
        self.encb.set_text('')
        self.enca.set_text('')

	if foundkey:
	    mykey = foundkey.group(1)
	    myres = keyfindthree.search(mykey)
	    if myres:
                self.encd.set_text(myres.group(2))
		mykey = myres.group(1)
	    myres = keyfindtwo.search(mykey)
	    if myres:
                self.encc.set_text(myres.group(2))
		mykey = myres.group(1)
	    myres = keyfindone.search(mykey)
	    if myres:
                self.encb.set_text(myres.group(2))
		mykey = myres.group(1)
	    self.enca.set_text(mykey)

        vb.pack_start(self.enca,expand=FALSE)
        vb.pack_start(self.encb,expand=FALSE)
        vb.pack_start(self.encc,expand=FALSE)
        vb.pack_start(self.encd,expand=FALSE)
	self.enca.show()
	self.encb.show()
	self.encc.show()
	self.encd.show()
	self.box.pack_start(hb,expand=FALSE) 
        hb.show() 
	hb.pack_start(vb,expand=FALSE) 
        vb.show() 

    def save(self,msgbox=FALSE): 
        import os 


        t = ''
	if self.encc.get_text() == '':
  	   if self.encd.get_text() != '': 
              t = self.encd.get_text()
	if t != '':
              self.encc.set_text(t)
	if t != '':
             self.encd.set_text('')

        t = ''
	if self.encb.get_text() == '':
  	   if self.encc.get_text() != '': 
              t = self.encc.get_text()
	if t != '':
              self.encb.set_text(t)
	if t != '':
             self.encc.set_text('')

        t = ''
	if self.enca.get_text() == '':
  	   if self.encb.get_text() != '': 
              t = self.encb.get_text()
	if t != '':
              self.enca.set_text(t)
	if t != '':
             self.encb.set_text('')


	if self.enca.get_text() != '':
           os.system('iwconfig %s enc %s%s%s' % (self.interface.get_text(), '"', self.enca.get_text(), '"'))
	if self.encb.get_text() != '':
           os.system('iwconfig %s enc %s[1]%s%s' % (self.interface.get_text(), '"', self.encb.get_text(), '"'))
	if self.encc.get_text() != '':
           os.system('iwconfig %s enc %s[2]%s%s' % (self.interface.get_text(), '"', self.encc.get_text(), '"'))
	if self.encd.get_text() != '':
           os.system('iwconfig %s enc %s[3]%s%s' % (self.interface.get_text(), '"', self.encd.get_text(), '"'))

	if self.essid.get_text() == '':
           os.system('iwconfig %s essid "ANY"' % self.interface.get_text())
        else:
           os.system('iwconfig %s essid "%s"' % (self.interface.get_text(), self.essid.get_text()))

        fin = open('/etc/pcmcia/wireless.opts','r')  
	data = fin.read();
        fin.close()

        remove = re.compile('# -+ START SECTION TO REMOVE -+.*# -+ END SECTION TO REMOVE -+', re.DOTALL);
        data = remove.sub(' ', data)

        start = re.compile('\\n[*,]+\\)\\n')
        essidfind = re.compile('ESSID=\\"[^"]*\\"')
        keyfind = re.compile('KEY=\\"[^"]*\\"')

	if self.essid.get_text() == '':
           data = essidfind.sub('ESSID="ANY"\n', data)
        else:
           data = essidfind.sub('ESSID="%s"\n' % self.essid.get_text(), data)

        t = ''
	if self.encb.get_text() == '':
	   t = self.enca.get_text()
        else:
	   if self.enca.get_text() != '':
	      t = '%s' % self.enca.get_text()
        if self.encb.get_text() != '':
	   t = '%s enc [1]%s' % (t, self.encb.get_text())
        if self.encc.get_text() != '':
	   t = '%s enc [2]%s' % (t, self.encc.get_text())
        if self.encd.get_text() != '':
	   t = '%s enc [3]%s' % (t, self.encd.get_text())

        if t != '':
           data = keyfind.sub('KEY="%s"\n' % t, data)


        fout = open('/etc/pcmcia/wireless.opts','w')  
        fout.write(data)
        fout.close() 

        os.system('chmod 555 /etc/pcmcia/wireless.opts')


        ret = Applet.save(self,msgbox) 
 
applet_instance = applet() 
